﻿/* All operations and setting related to user interface, detached from
   player.js. 
   Created by Zoominla, 12-25-2008         
*/
if(typeof(XULPLAYER_GUI_INCLUDE) != "boolean") {
	XULPLAYER_GUI_INCLUDE = true;

var mainwnd;
var plMan = null;	// Play lists manager
var progressbar;
var playButtons = new Array("play_icon", "stop_icon",  "fr_icon", "ff_icon");
var listItemIds = new Array("mainTab", "optAutoLevel", "optVideoOut", "optAudioOut", "optPriority", "optAudioOut", "optAudioChannels", "optPriority");
var fileInfoXML = null;

var focusFromPlugin = false;
var homeURL = null;
var subfont = null;
var subFile = null;
var mediaLibPath;
var playType = PLAY_TYPE_FILE;

var holdOnProgress = false;

var mp = null;
var mc = null;
var swfPlayer = null;		// Control the playing of SWF file
var userDataPath = null;	// Place playlist file and lyrics file
/*============================================================
  A list of File types used :
	   Image: image type (ex. BMP, GIF, PNG, JPG, etc)
	   Url: this type stands for web page (ex. html, asp, php)
	   Stream: Streams on the internet, (ex. http, rtsp, mms)
	   SWF: flash video
	   Common media type (ex. AVI, MP4, MP3, RMVB, MOV, etc.)
=============================================================*/

function init()
{
	try { netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect'); }
        catch  (e) { alert ('Error setting privilege.'); }
	
	mp = new CPlayer(player);
	mc = new CConvert(player);
	
	// Initialize the visible elements of the GUI, then startup
	for (var x in listItemIds) loadSelectedIndex(listItemIds[x]);
	homeURL = getLocalString("homeURL");
	if (!homeURL) homeURL = "http://xulplayer.sourceforge.net/start";

	//Initialize user data path
	initUserDataPath();
	toggleDualMode();
	refreshEffectsTab();
	mediaLibPath = Io.getSpecialDir("defaults", "CurProcD").path;
	toggleMediaLib();
	plMan = new CPlaylistMan('listManager');
	plMan.enableRandom(isChecked('opt-shuffle'));
	plMan.enableRepeat(isChecked('opt-repeat'));
	plMan.initialize();
	if (window.initProjectorOpts) initProjectorOpts();
	
	// initialize player and events handler after GUI show up
	mainwnd = $("main");
	progressbar = $("timebar");
	swfPlayer = new SwfPlayer();
	swfPlayer.setLoopCallback(swfPlayCallback);
	swfPlayer.setStopCallback(swfStopCallback);
	
	// initialize Drag & Drop Event
	initDragDropEvent();
	initSkinMenuItems();
	window.addEventListener("focus", focusMethod, true);
	// initialize player
	mp.initialize();
	mp.setStartCallback(onPlayerStart);
	mp.setStopCallback(onPlayerStop);
	mp.setPauseCallback(onPlayerPaused);
	mp.setLoopCallback(playLoop);

	// initialize converter
	mc.setLoopCallback(encodeLoopCallback);
	mc.setStopCallback(encodeStopCallback);

	// set view mode
	setViewMode();
	// update volume scale
	$("volscale").value = mp.getVolume();
	
	// schedule a CPU info display
	self.setTimeout(showCPUInfo, 1000);

	// load mcex
	liteBrowserInit("http://www.mcex.org");
	browserObject.setAttribute("src", "http://www.mcex.org");

	// load files from command line
	processCommandLine();
	showMediaInfo();
	/*var xmlhttp = new XMLHttpRequest;
	if (xmlhttp) {
		xmlhttp.open("HEAD", homeURL, false);
		xmlhttp.send(null);
		if (xmlhttp.status == 200)
			loadPage(homeURL);
	}*/
	loadPage(homeURL);
}

function uninit()
{
	if(plMan) plMan.save();
	mp.unInitialize();
	if (window.uninitProjectorOpts) uninitProjectorOpts();
}

const MCEX_MIN_WIDTH = 900;
const MCEX_MIN_HEIGHT = 720;
const NORMAL_MIN_WIDTH = 500;
const NORMAL_MIN_HEIGHT = 400;

function closeWindow()
{
	mp.setTrayIcon(false);
	window.close();
}

function startPlay(filename, type)
{
	if (mp.isPlaying()) {
		mp.stop();
	}
	if(swfPlayer.isPlaying()) {
		swfPlayer.stop();
	}

	if (!filename) {
		filename = plMan.getCurrentFile();
		if(!filename) return;
	}
	mp.setPlayingFile(filename);
	mp.enablePlayNext(true);
	if (!type) {
		type = getFileType(filename);
	}
	if(type.indexOf("Image")!=-1 || type == "Web Page"){   // Local pages
		loadPage("file://" + filename);
		mp.enablePlayNext(false);
		return;
	} else if (type == "Url") {         //Weg pages on internet
		loadPage(filename);
		playType = PLAY_TYPE_URL;
		return;
	} else if (type == "SWF") {
		playSwf(filename);
		return;
	}
	var opts = getPlayCommandOptions();
	var detached = isChecked("menuDetached");
	$("videoBox").selectedIndex = INDEX_VIDEO;
	mp.play(opts, !detached);
	$("stats").label = filename;
	if(curViewMode !=  VIEW_FULL && curViewMode !=  VIEW_DEVICE && !winMaxed && !fs) {
		fitVideoSize(true);
	}
	
	if(!fs) setViewMode();
	if(!mp.isPlaying()) {
		loadPage(homeURL);
	}
	
	//if (dualmode) {
	//	setCrossVolume();
	//}
	// look for lyric file and 
	findLyricAndDisplay();
	showMediaInfo(filename);
}

// Open Stream. ex: http, rtsp, mms
function openStream()
{
	var tips = getLocalFormatString("urlTips", "Xulplayer", "http, rtsp, mms");
	var urls = prompt(tips, getLocalString("urlTitle"), "");
	if (urls) {
		addFile(urls, 0);
		startPlay(urls);
	}
}

function play_cmd()
{
	if (!plMan.getCurrentFile()) {
		openFile();
	}
	startPlay();
}

function pause_cmd()
{
	if(playType == PLAY_TYPE_SWF) {
		//swfPlayer.pause();
	} else {
		mp.pause();
	}
}

// Open a file and play it
function playFile_cmd()
{
	var fileName = openFile();
	startPlay(fileName);
}

function stop_cmd()
{
	mp.enablePlayNext(false);
	mp.stop();
	subFile = null;
	if(playType == PLAY_TYPE_SWF) {
		swfPlayer.stop();
		if(swfPlayer.isPlaying()) return;
	}
	if ($("videoBox").selectedIndex == INDEX_PAGES) {
		loadPage("html/videobox.html");
	} else if(!dualmode && !mp.isPlaying()){
		loadPage(homeURL);
	}
}

function prev_cmd()
{
	plMan.movePrevious();
	startPlay();
}

function next_cmd()
{
	plMan.moveNext();
	startPlay();
}

function opendir_cmd()
{
	var dir = Io.openDir('Open Folder');
	if (dir) {
		$('dirtext').value = dir.path;
	}
}

function updatePlayerState()
{
	if (mp.isPlaying()) {
		setAttr("play_icon", "command", "cmdPause");
		//mainwnd.setAttribute("title", "&player.title; - " + playingFile[playerIndex]);
		for (var i = 1; i < playButtons.length; i++) {
			enable(playButtons[i]);
		}
		duration = mp.getDuration();
		if (duration > 0) {
			enable("timebar");
			progressbar.setAttribute("max", duration);
		} else {
			disable("timebar");
		}
		setAttr("btn_screenshot", "disabled", !mp.hasVideo());
	} else {
		setAttr("play_icon", "command", "cmdPlay");
		for (var i = 1; i < playButtons.length; i++) {
			disable(playButtons[i]);
		}
		disable("timebar");
		duration = 0;
		progressbar.value = 0;
		disable("btn_screenshot");
		if(!dualmode) $("videoBox").selectedIndex = INDEX_PAGES;
		if(mp.playNextEnabled() && !dualmode) {
			plMan.moveNext();
			startPlay();
		}
	}
}

function onPlayerStart()
{
	// load file info from plugin;
	var xmlInfo = mp.getClipInfoXML();
	if(xmlInfo) {
		fileInfoXML = new XMLDom();
		fileInfoXML.loadXML(xmlInfo);
	}
	showFileInfo();
	updatePlayerState();
}

function onPlayerStop()
{
	updatePlayerState();
}

function onPlayerPaused()
{
	//updatePlayerState();
}

function playLoop()
{
	// update progress bar
	
	if (holdOnProgress) return;
	var pos = mp.getCurPos();
	if (pos >= 0) {
		$("state").label = mp.getTimeString(pos / 1000) + " / " + player.getTimeString(duration / 1000);
		progressbar.value = pos;
		//update lyric
		if(ifDisplayLyric) updateLyricDisplay(pos);
		if(fs) showOrHideProgressbar();
	} else {
		var d = new Date();
		$("state").label = padNumber2(d.getHours()) + ":" + padNumber2(d.getMinutes()) + ":" + padNumber2(d.getSeconds());
		progressbar.value = 0;
	}
}

function seekToClickPos(e)
{
	// Progressbar event process
	if(!e) {
		e = window.event;
	}
	var pBar = e.target;
	var barLeft = pBar.boxObject.x;
	var barWidth = pBar.boxObject.width;
	if(!barWidth && barWidth <= 0) return;
	var eventX = e.clientX;
	var percent = (eventX-barLeft)/barWidth;
	var pos = percent * progressbar.getAttribute('max');
	if(playType == PLAY_TYPE_SWF) {
		//swfPlayer.gotoFrame(pos);
	} else {
		pos /= 1000.0;
		mp.seekToPos(pos);
	}
	$("play-toolbar").focus();
}

function switchAudio()
{
	var ret = mp.switchAudio();
	document.getElementById("stats").label = ret;
}

function refreshEffectsTab()
{
	var s = $("tabEffects").getElementsByTagName("scrollbar");
	var i;
	for (i = 0; i < s.length; i++) {
			s[i].onmouseup();
	}
}

function applyPlayerOptions()
{
	if (mp.isPlaying()) {
		var pos = mp.m_curPos;
		mp.stop();
		startPlay(mp.getPlayingFile());
		pos /= 1000.0
		mp.seekToPos(pos);
	}
}

function switchPlayer(index)
{
	$('dualVideoOptions').selectedIndex = index;
	mp.setActivePlayer(index);
	$("stats").label = mp.getPlayingFile();
	updatePlayerState();
}

function takeScreenshot()
{
	var result = mp.screenshot();
	var pngName = new String();
	if(!result) return;
	var index1 = result.indexOf("\'");
	var index2 = result.lastIndexOf("\'");
	pngName = result.substring(index1+1, index2);
	result = getLocalFormatString("tipScreenshot", pngName);
	if (isChecked("tipScreenshot")) msgbox(result, title);
}

function resetSubSync()
{
	var delay = prompt(getLocalString("subSyncTips"), getLocalString("subSyncTitle"), 0);
	if(!delay) return;
	delay = parseInt(delay);
	mp.resetSubDelay(delay);
}

function resetAoSync()
{
	var delay = prompt(getLocalString("subSyncTips"), getLocalString("aoSyncTitle"), 0);
	if(!delay) return;
	delay = parseInt(delay);
	mp.resetAudioDelay(delay);
}

function loadSubFont()
{
	var loadFontTitle = getLocalString("loadFontTitle");
	var files = Io.loadFile(loadFontTitle, 'Font|*.ttf');
	if(files instanceof Array) {
		subfont = files[0].path;
	}
	if(subfont) applyPlayerOptions();
 
}
function loadSubFile()
{
	var loadFileTitle = getLocalString("loadSubTitle");
	var filter = 'Subtitle(*.srt, *.sub, *ssa, *ass)|*.srt; *.sub; *ssa; *ass';
	var files = Io.loadFile(loadFileTitle, filter);
	if(files instanceof Array) {
		subFile = files[0].path;
	}
	if(subFile) applyPlayerOptions();
}

function addFolder(recurse)
{
	var dir = Io.openDir('Open Folder');
	if(!dir) return;
	addSubFolders(dir, recurse);
	$("fullView").setAttribute("checked", true);
	//setViewMode();
}

function addSubFolders(dir, recursive)
{
	var files = dir.directoryEntries;
	while(files.hasMoreElements()) {
		var afile = files.getNext();
		afile.QueryInterface(Components.interfaces.nsIFile);
		if(afile.isFile()) {
			var fullPath = afile.path;
			var ext = getFileExt(fullPath);
			var fileSize = afile.fileSize;
			addFile(fullPath, fileSize / 1024);
		}
		if(afile.isDirectory() && recursive) {
			addSubFolders(afile, recursive);
		}
	}             
}

//--------------------------------------------------------------------------------------
// Add file to current playlist
function addFile(filename, filesize)
{
	if (!filename) return;
	var fileType = "";
	var fileSizeStr = "";
	
	if (filesize && filesize == -1) {		// url type
		fileType = "Url";
	} else {
		if(filesize) {
			fileSizeStr = normalizeFileSize(filesize);
		}
		fileType = getFileType(filename);
	}
	plMan.addFile(filename, fileSizeStr, fileType);
	if (!mp.isPlaying()) {
		startPlay(filename);
	}
}

// Open file dialog and add file to current playlist
function openFile()
{
	//the type of localFile is nsILocalFile
	var filters =  ['All|*.*', 'AVI|*.avi', 'MP4|*.mp4', 'Windows Media|*.asf; *.wmv; *.wma',
					'MPEG|*.mpg', 'MP3|*.mp3', 'FLAC|*.flac',
					'RealMedia|*.rmvb; *.rm', 'QuickTime|*.mov; *.mp4'
				   ];
	var localFiles = Io.loadFile("Play File", filters, true);
	if(localFiles instanceof Array) {
		for(var i=0; i<localFiles.length; ++i) {
			var filesize = localFiles[i].fileSize;
			filesize /= 1024;	//Convert to KB
			var filename = localFiles[i].path;
			// add file to playlist
			addFile(filename, filesize);
			//$("playlist").selectedIndex = $("playlist").itemCount - 1;
			//$("playlist").ondblclick();
		}
	}
	return filename;
}

// Open playlist
function loadPlayList()
{ 
	//the type of localFile is nsILocalFile
	var filters =  ['xulplayer playlist(*.xpl)|*.xpl', 'm3u|*m3u'];
	var localFiles = Io.loadFile("Play File", filters);
	if(localFiles instanceof Array) {
		plMan.openList(localFiles[0].path);
	}
}

function newPlayList()
{
	var listName = prompt("Please input a name for creating new list", "New list");
	if(listName) plMan.newList(listName);
}

function renamePlayList()
{
	var listName = prompt("Please input a new name", "Rename list");
	if(listName) plMan.renameList(listName);
}

function loadPage(url)
{
	$("videoBox").selectedIndex = INDEX_PAGES;
	$("frame").setAttribute("src", url);
}

function setLang(lang)   //language select
{
	try {
	  var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  prefs.setCharPref("general.useragent.locale", lang);
	}
	catch ( err ) {
	  alert( "SelectLanguage - " + err);
	}
	if(isChecked("tipSetLang")) msgbox(getLocalString("setLangNotice"), title);
}

function getFileInfo(type, info)
{
	var r = fileInfoXML.getElementsByTagName(type);
	if (r.length > 0) {
			r = r[0].getElementsByTagName(info);
			if (r.length > 0) return r[0].firstChild.nodeValue;
	}
	return null;
}

function showFileInfo()
{
	if(fileInfoXML) {
		var xsl = loadXML("xslt/fileinfo.xsl");
		transformXML(fileInfoXML, xsl, "tabInfo");
	}
}

function getPlayCommandOptions()
{
	var opts = " -framedrop -autosync 30 -vf screenshot";
	
	/*
	if (window.GetProjectorOpts) {
		var projOpts = GetProjectorOpts();
		if (projOpts) {
			opts += projOpts;
			detached = true;
		}
	}
	
	if (isChecked("optEnableColor")) {
		var contrast = parseFloat(getValue("optContrast"));
		var brightness = parseFloat(getValue("optBrightness"));
		var sat = parseFloat(getValue("optSaturation"));
		var gamma = parseFloat(getValue("optGamma"));
		var gammared = parseFloat(getValue("optGammaRed"));
		var gammagreen = parseFloat(getValue("optGammaGreen"));
		var gammablue = parseFloat(getValue("optGammaBlue"));

		opts += " -vf-add eq2=" + gamma +
			":" + contrast +
			":" + brightness +
			":" + sat +
			":" + gammared +
			":" + gammagreen +
			":" + gammablue
	}*/
	
	//if (isChecked("optEnableColor")) opts += " -vf-add eq2";
	
	if (isChecked("optPostProc")) {
		var ppopts = getValue("optAutoLevel");
		if (isChecked("optDeblockH"))
			ppopts += "/" + getAttr("optDeblockH", "value");
		if (isChecked("optDeblockV"))
			ppopts += "/" + getAttr("optDeblockV", "value");
		if (isChecked("optDering"))
			ppopts += "/" + getAttr("optDering", "value");
		if (isChecked("optDenoise"))
			ppopts += "/" + getAttr("optDenoise", "value");
		if (document.getElementById("optDeint").selectedIndex > 0)
			ppopts += "/" + getAttr("optDeint", "value");
		if (ppopts.length > 1)
			opts += " -vf-add pp=" + ppopts;
	}
	if(isChecked("rotate90")){              //Rotate / flip / mirror
		opts += " -vf-add rotate=2";
	} else if(isChecked("rotate270")) {
		opts += " -vf-add rotate=1";
	} else if(isChecked("rotate90Flip")) {
		opts += " -vf-add rotate=0";
	} else if(isChecked("rotate270Flip")) {
		opts += " -vf-add rotate=3";
	} else if(isChecked("mirror")) {
		opts += " -vf-add mirror";
	} else if(isChecked("flip")) {
		opts += " -vf-add flip";
	}
	//opts += " -identify";
	switch ($("optAspect").selectedIndex) {
	case 0:
		if (!isChecked("keepAspect")) opts += " -nokeepaspect";
		break;
	case 1:
		opts += " -aspect 4:3";
		break;
	case 2:
		opts += " -aspect 16:9";
		break;
	case 3:
		opts += " -aspect 2.35";
		break;
	}
	var vo = $("optVideoOut").selectedItem.value;
	if (vo && vo != "") opts += " -vo " + vo;
	var ao = $("optAudioOut").selectedItem.value;
	if (ao && ao != "") opts += " -ao " + ao;
	var channels = $("optAudioChannels").selectedItem.value;
	if (channels != "") {
		if (channels == "1:0" || channels == "1:1") {
			opts += " -channels 2 -af-add channels=1:" + channels;
		} else {
			opts += " -channels " + channels;
		}
	}
	var priority = $("optPriority").selectedItem.value;
	if (priority && priority != "") opts += " -priority " + priority;
	// specify subtitle options
	var syscp = mp.getCodePage();
	if(! subfont) subfont = (syscp == 936 ? "simhei.ttf" : getLocalString("subFont"));
	var windir = mp.getEnv("windir");
	opts += " -subfont-text-scale 3 -subfont-blur 2 -subfont-outline 2 -sub-fuzziness 1 -subcp cp" + syscp + " -subfont " + windir + "\\fonts\\" + subfont;
	if(subFile) opts += " -sub " + subFile;
	
	//if ($("dualmon").checked) opts += " -adapter " + $("monid").value + " -fs";
	// extra options
	var extra = getValue("extraCmdLine");
	if (extra) opts += " " + extra;
	return opts;
}

}

function showCPUInfo()
{
	var cpuinfo = mp.getCPUInfo();
	if (cpuinfo.length > 0) {
		$("cpuinfo").label = mp.getCPUInfo();
	} else {
		self.setTimeout(showCPUInfo, 500);
	}
}

var lastParsedFile = null;

function showMediaInfo(filename)
{
	if (!filename) filename = plMan.getSelectedFile();
	if (filename && (!lastParsedFile || filename != lastParsedFile)) {
		$("mediaInfoText").value = "";
		$("mediaInfoText").value = mc.dumpMediaInfo(filename, true);
		lastParsedFile = filename;
	}
}

function encodeLoopCallback()
{
	$("encode_progress").value = mc.getPercent();
}

function encodeStopCallback()
{
	$("encode_progress").value = 100;
	alert("Conversion done!")
	$("encode_progress").hidden = true;
}

function encodeChooseOutputDir()
{
	var dir = Io.openDir('Set Output Folder');
	if (dir) {
		mc.setPref("overall.task.destdir", dir.path)
	}
}

function encodeStart(filename)
{
	while (!filename) {
		//alert(player.convertPrefs);
		filename = mp.getPlayingFile();
		if (filename) break;
		filename = plMan.getSelectedFile();
		if (filename) break;
		alert("No file to transcode");
		return;
	}
	$("encode_start").disabled = true;
	$("encode_start").setAttribute("command", "cmdEncodeStop");
	mc.start(filename);
	$("encode_progress").hidden = false;
	$("encode_start").disabled = false;
}

function encodeStop()
{
	if(mc.isConverting()) {
		mc.end();
	}
	$("encode_start").setAttribute("command", "cmdEncodeStart");
}

function encodePause()
{
	if(mc.isConverting() || mc.isWaiting()) {
		mc.pause();
	}
}


//-----------------------Helper function------------------------
function initUserDataPath()
{
	try {
		var appDataPath = mp.getEnv('appdata');
		var userDataPathObj = Io.getFileFrom(appDataPath);
		if(userDataPathObj) {
			userDataPathObj.append("Broad Intelligence");
			if(userDataPathObj && !userDataPathObj.exists()) {
				userDataPathObj.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 420);
			}
			userDataPathObj.append('Xulplayer');
			if(userDataPathObj && !userDataPathObj.exists()) {
				userDataPathObj.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 420);
			} 
			userDataPath = userDataPathObj.path;
			userDataPathObj.append('lyrics');
			if(userDataPathObj && !userDataPathObj.exists()) {
				userDataPathObj.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 420);
			}
			lyricPath = userDataPathObj.path;
		}
	} catch (e) {
		
	}
	
}

function processCommandLine()
{
	nsCommandLine = window.arguments[0].QueryInterface(Components.interfaces.nsICommandLine);
	if(nsCommandLine && nsCommandLine.length > 0) {
		var firstParam = nsCommandLine.getArgument(0);
		var startParamIndex = 0;
		switch (firstParam) {
		case "-url":
			var fileType = "Url";
			playType = PLAY_TYPE_URL;
			// -1 indicate it's a url
			var filename = nsCommandLine.getArgument(1);
			if (filename.indexOf("application.ini") < 0) {
				addFile(filename, -1);
				startPlay(filename, fileType);
			}
			break;
		case "-app":
			startParamIndex = 2;
		default:
			if (startParamIndex < nsCommandLine.length) {
				for (var i = startParamIndex; i < nsCommandLine.length; i++)
					addFile(nsCommandLine.getArgument(i));
				startPlay(nsCommandLine.getArgument(startParamIndex));
			}
		}
	} 
}
//-------------------------- SWF flash playback control -----------------------
// Main.xul isn't in the same domain with swf file, so can't control swf playback
// Need to be fixed
function playSwf(filename)
{
	playType = PLAY_TYPE_SWF;
	$("videoBox").selectedIndex = INDEX_SWF;
	swfPlayer.setPlayFile(filename);
	mp.enablePlayNext(false);
	setTimeout(function() {
		swfPlayer.play();
		var totalFrames = swfPlayer.getTotalFrames();
		if ( totalFrames > 0) {
			enable("timebar");
			for (var i = 1; i < playButtons.length; i++) {
				enable(playButtons[i]);
			}
			progressbar.setAttribute("max", totalFrames);
			setAttr("play_icon", "command", "cmdPause");
		} else {
			disable("timebar");
		}
	}, 300);
}

function swfPlayCallback()
{
	var curFrmae = swfPlayer.getCurFrame();
	progressbar.value = curFrmae;
}

function swfStopCallback()
{
	mp.enablePlayNext(true);
	updatePlayerState();
}

function SwfPlayer()
{
	this.plugin = $("swfVideo");
	this.file = null;		// file name
	this.loopCallback = null;
	this.stopCallback = null;
	this.timerId = null;
}

SwfPlayer.prototype.setPlayFile = function(fileName) {
	if(fileName == null) return;
	this.file = fileName;
	this.plugin.LoadMovie(0, this.file);
	//this.plugin.setAttribute('src', this.file);
};

SwfPlayer.prototype.isPlaying = function() {
	return this.plugin.IsPlaying();
};

SwfPlayer.prototype.play = function() {
	if(this.file == null) return;
	if(this.plugin.IsPlaying()) {
		this.plugin.StopPlay();
	}
	this.plugin.Play();
	if(this.isPlaying) {
		this.playLoop();
	}
};

SwfPlayer.prototype.pause = function() {
	if(this.file == null) return;
};

SwfPlayer.prototype.stop = function() {
	if(this.file == null) return;
	this.plugin.setAttribute('src', '');
	this.file = null;
};

SwfPlayer.prototype.getTotalFrames = function() {
	return this.plugin.TotalFrames();
};

SwfPlayer.prototype.getCurFrame = function() {
	return this.plugin.CurrentFrame();
};

SwfPlayer.prototype.gotoFrame = function(num) {
	if(typeof(num) == 'string') num = parseInt(num);
	if(num > 0 && num < this.getTotalFrames()) {
		this.plugin.GotoFrame(num);
	}
};

SwfPlayer.prototype.setLoopCallback = function(func) {
	if(typeof(func) == 'function') {
		this.loopCallback = func;
	}
};

SwfPlayer.prototype.setStopCallback = function(func) {
	if(typeof(func) == 'function') {
		this.stopCallback = func;
	}
};

SwfPlayer.prototype.playLoop = function() {
	if(typeof(this.loopCallback) == 'function') {
		this.loopCallback();
	}
	var me = this;
	if(this.isPlaying() && this.file) {
		this.timerId = setTimeout(function(){me.playLoop()}, 200);
	} else {
		if(typeof(this.stopCallback) == 'function') {
			this.stopCallback();
			clearTimeout(this.timerId);
		}
	}
};
