﻿if(typeof(WINDOW_CHANGE) != "boolean") {
	WINDOW_CHANGE = true;
    
var fs = false;
var curViewMode = null;
var prevViewMode = null;
var noEventTime = 2100;
var winMaxed = false;

function toggleFullScreen()
{
    alert('fullscreeen');
	fs = !fs;
    noEventTime = 2100;
    var resizers = [$("resizer-left"), $("resizer-right"), $("resizer-top"),
                    $("resizer-bottom"), $("resizer-topleft"),$("resizer-bottomright")];
    if (fs) {
        for(var i in resizers)
            resizers[i].hidden = true;
        mp.setWindowTop(true);
        hideAllExceptVideo(true);
        window.maximize();
    } else {
        for(var i in resizers)
            resizers[i].hidden = false;
        setViewMode();
		var playToolbar = $("play-toolbar");
		playToolbar.hidden = false;
        toggleMediaLib();
        window.restore();
        if(!isChecked("windowTop"))
            mp.setWindowTop(false);
    }
}

function toggleMaximize()
{
	winMaxed = !winMaxed;
	if (winMaxed)
		window.maximize();
	else
		window.restore();
}

function toggleDualMode()
{
    dualmode = isChecked("dualMode");
    $('dualVideoOptions').hidden = !dualmode;
    if (!dualmode) {
        mp.setActivePlayer(0);
		mp.exitDualMode();
    } 
    window.sizeToContent();
}

function setViewMode(mode)
{
	var titlebar = $('titlebar');
	var tabs = $('mainTabBox');
	var toolbar = $('navToolbar');
	var menu = $('mainMenuBar');
	var sb = $('statusResizeBar');
	var playToolbar = $("play-toolbar");
	var splitter = $("panelSplit");
	//var panelDeck = $("panelDeck");
	var mcexContainer = $("mcexBox");
	var mcexSplitter = $("mcexSplitter");
	if (!mode) {
		if (isChecked('fullView'))
			mode = VIEW_FULL;
		else if(isChecked('simpleView'))
			mode = VIEW_SIMPLE;
		else if(isChecked('deviceView'))
			mode = VIEW_DEVICE;
		else
			mode = VIEW_COMPACT;
		$("viewSlider").value = mode;
	} else {
		switch (mode) {
		case VIEW_FULL:
			$("fullView").setAttribute("checked", true);
			break;
		case VIEW_SIMPLE:
			$("simpleView").setAttribute("checked", true);
			break;
		case VIEW_DEVICE:
			$("deviceView").setAttribute("checked", true);
			break;
		case VIEW_COMPACT:
			$("compactView").setAttribute("checked", true);
			break;
		}
		$("viewSlider").value = mode;
	}
	
	switch (mode) {
	case VIEW_FULL:
	case VIEW_DEVICE:
		titlebar.hidden = false;
		tabs.hidden = false;
		toolbar.hidden = false;
		menu.hidden = false;
		sb.hidden = false;
		playToolbar.hidden = false;
		splitter.hidden = false;
		break;
	case VIEW_SIMPLE:
		titlebar.hidden = false;
		tabs.hidden = true;
		toolbar.hidden = true;
		menu.hidden = false;
		sb.hidden = true;
		playToolbar.hidden = true;
		splitter.hidden = true;
		break;
	case VIEW_COMPACT:
		titlebar.hidden = false;
		tabs.hidden = true;
		toolbar.hidden = true;
		menu.hidden = false;
		sb.hidden = false;
		playToolbar.hidden = false;
		splitter.hidden = true;
		break;
	}
		
	if (mode != curViewMode) {
		// view mode has been changed
		curViewMode = mode;
		var isDeviceMode = (mode == VIEW_DEVICE);
		mcexContainer.hidden = !isDeviceMode;
		mcexSplitter.hidden = !isDeviceMode;
	}

	prevViewMode = curViewMode;
	onResize();
}

function zoomVideo()
{
    if (isChecked("keep25")) {
        mp.zoom(0.25);
    } else if (isChecked("keep50")) {
        mp.zoom(0.5);
    } else if (isChecked("keep150")) {
        mp.zoom(1.5);
    } else if (isChecked("keep200")) {
        mp.zoom(2);
    } else if (isChecked("keep100")) {
        mp.zoom(1);
    } else if (isChecked("keepvideo")){
        mp.zoom(-1.5);  // Need a number < 0 , but can't be negative integer
        fitVideoSize(false);
    } else {
        mp.zoom(0);
    }
}

function fitVideoSize(ifOriginal)
{
    var vh = 0, vw = 0;
    if(ifOriginal){
        vh = mp.getVideoHeight(); vw = mp.getVideoWidth();
    } else {
        vw = mp.getRealVideoWidth(); vh = mp.getRealVideoHeight(); 
    }
    if(vh <= 0 || vw <= 0 || vh > window.screen.height || vw > window.screen.width) return;
    var boxh = $("videoBox").boxObject.height;
    var boxw = $("videoBox").boxObject.width;
    var h = window.innerHeight, w = window.innerWidth;
    window.innerWidth = w - boxw + vw;
    window.innerHeight = h - boxh + vh;
    onResize();
}

function setWindowTop()
{
	$('windowTop').setAttribute('checked',!isChecked('windowTop')); 
    if(isChecked("windowTop"))
        mp.setWindowTop(true);
    else 
        mp.setWindowTop(false);
}
function focusMethod()
{
    if(focusFromPlugin){
        $('windowIcon').focus();
        focusFromPlugin = false;
        if(fs){
            noEventTime = 0;
            $("play-toolbar").hidden = false;
        }
    }
}

function onResize()
{
    switch (curViewMode) {
    case VIEW_FULL:
	case VIEW_DEVICE:
        if (window.outerWidth < 1000)
            window.outerWidth=1000;
        if (window.outerHeight < 548)
            window.outerHeight=548;
	break;
    case VIEW_COMPACT:
        if (window.outerWidth < 420)
            window.outerWidth=420;
        if (window.outerHeight < 280)
            window.outerHeight=280;
		break;
    case VIEW_SIMPLE:
       if (window.outerWidth < 420 )
            window.outerWidth=420;
        if (window.outerHeight < 270)
            window.outerHeight=270;
		break;
    }
    return true;  
}

function hideAllExceptVideo(ifHide)
{
    var elements = [$("titlebar"), $('mainTabBox'), $('navToolbar'), $('mainMenuBar'),
                    $('statusResizeBar'),$("play-toolbar"), $("panelSplit"), $("media-lib-bar"),
                    $("list-split")];
    for(var i in elements){
        elements[i].hidden = ifHide;
    }
}
function showOrHideProgressbar()    //when noEvent time is bigger than 1500, hide progressbar
{
    noEventTime += mp.m_timeInterval;
    if(noEventTime > 2000)
        $("play-toolbar").hidden = true;
    else
        $("play-toolbar").hidden = false;
    if(noEventTime > 20000) noEventTime = 20000;
}       

function toggleMediaLib()
{
    var mlbar = $("media-lib-bar");
    if ($("menu-show-ml").getAttribute("checked") == "true") {
            mlbar.hidden = false;
            mlbar.nextSibling.hidden = false;
            var xsl = loadXML("medialib/catalog.xsl");
            var xml = loadXML("file:///" + mediaLibPath + "\\filelist.xml");
            if (xsl && xml) transformXML(xml, xsl, "file-list");
    } else {
            mlbar.hidden = true;
            mlbar.nextSibling.hidden = true;
    }
}

function getStyle(elem,styleProp)
{
  var v = null;
  if (elem) {
    var s = document.defaultView.getComputedStyle(elem,null);
    v = s.getPropertyValue(styleProp);
  }
  return v;
}

}